declare module 'ember-testing/lib/adapters/adapter' {
  import EmberObject from '@ember/object';
  /**
     @module @ember/test
    */
  /**
      The primary purpose of this class is to create hooks that can be implemented
      by an adapter for various test frameworks.

      @class TestAdapter
      @public
    */
  interface Adapter extends EmberObject {
    asyncStart(): void;
    asyncEnd(): void;
    exception(error: unknown): never;
  }
  const Adapter: Readonly<typeof EmberObject> &
    (new (owner?: import('@ember/owner').default | undefined) => EmberObject);
  export default Adapter;
}
